<?
    class NewsList
    {
        private $_list;
        private $_db;
        
        function NewsList( $db, $table )
        {
            $this->_db = $db;
            $this->_list = array();
            
            $query = $db->query( "select * from $table order by news_date desc" );
            
            while( $query->hasMoreRows() )
            {
                $row = &$query->getRow();
                $entry = array();
                foreach( $row as $key => $value )
                {
                    if( $key == 'news_title' || $key == 'news_text' )
                        $entry[$key] = urldecode( $value );
                    else
                        $entry[$key] = $value;
                        
                }
                $this->_list[$entry['news_id']] = $entry;
            }
        }
        
        function uploadPicture( $pic )
        {
            $pic_name = "";
            if( $pic['name'] != '' && $pic['tmp_name'] != '' )
            {
                if( copy( $pic['tmp_name'], "pic/".$pic['name'] ) )
                {
                    $pic_name = $pic['name'];
                }
            }
            return $pic_name;
        }
        
        function createElement( $table, $title, $text, $pic )
        {
            $pic_name = $this->uploadPicture( $pic );
            
            $sqlcmd = "insert into $table (news_id, news_date, news_title, news_text, news_pic, news_flag) ".
                      "values( 0, NOW(), '".urlencode( $title )."', '".urlencode( $text )."', '$pic_name', 0 )";
            $this->_db->query( $sqlcmd );
        }
        
        function updateElement( $table, $entry )
        {
            $pic_name = $this->uploadPicture( $entry['news_pic'] );
            
            $sqlcmd = "update $table set ".
                "news_date='".$entry['news_date']."', ".
                "news_title='".urlencode($entry['news_title'])."', ".
                "news_text='".urlencode($entry['news_text'])."', ".
                (($pic_name != "") ? "news_pic='".$pic_name."', " : "").
                "news_flag='".$entry['news_flag']."' ".
                "where news_id=".$entry['news_id'];
            $this->_db->query( $sqlcmd );
        }
        
        function getList()
        {
            return $this->_list;
        }
        
        function getEmptyEntry()
        {
            return array( 
                'news_id' => 'Neu', 
                'news_date' => '',
                'news_title' => '',
                'news_text' => '',
                'news_pic' => '',
                'news_flag' => 0 
            );
        }
    };
    
    class NewsTable extends HTMLDiv
    {
        function NewsTable( $newsList )
        {
            parent::HTMLDiv( '', '', NULL );

            $map = array( 
                array( 
                    new HTMLDivText( "Id", "tabhead" ), 
                    new HTMLDivText( "Datum", "tabhead" ), 
                    new HTMLDivText( "Titel", "tabhead" ), 
                    new HTMLDivText( "aktiv", "tabhead" ),
                    new HTMLDivText( "Aktion", "tabhead" )
                )
            );
            
            foreach( $newsList as $entry )
            {
                $map[] = array(
                    new HTMLDivText( $entry['news_id'], "tabcell" ), 
                    new HTMLDivText( $entry['news_date'], "tabcell" ), 
                    new HTMLDivText( $entry['news_title'], "tabcell" ), 
                    new HTMLDivText( $entry['news_flag'], "tabcell" ), 
                    new HTMLLink( "?action=edit&id=".$entry['news_id'], "Bearbeiten", new HTMLText("Bearbeiten") )
                );
            }
            
            $actions = new HTMLSpan;
            $actions->addElement( new HTMLLink( "?action=new", "Neu", new HTMLText("Neu") ) );
            $actions->addElement( new HTMLText( " | " ) );
            $actions->addElement( new HTMLLink( "?", "Anzeigen", new HTMLText("Anzeigen") ) );
            
            $map[] = array( 
                new HTMLDivText( '&nbsp;', "empty" ), 
                new HTMLDivText( '&nbsp;', "empty" ), 
                new HTMLLink( "?action=logout", "Abmelden", new HTMLText("Abmelden") ),
                new HTMLDivText( '&nbsp;', "empty" ), 
                $actions    
            );
            
            $table = new HTMLTable( $map, 'newslist' );
            $this->addElement( $table );            
        }
    };
    
    class NewsFormCreate extends HTMLDiv
    {
        function NewsFormCreate( $entry )
        {
            global $_CFG;
            
            parent::HTMLElement( 'newsform', '', NULL );
            
            $backbutton = new HTMLButton( 'button', false, 'Zurck', 'formtext', '' );
            $backbutton->setClickHandler( 'document.location = "?action=admin"' );
            
            $control = new HTMLSpan;
            $control->addElement( $backbutton );
            $control->addElement( new HTMLButton( 'submit', true, 'Speichern', 'formtext', '' ) );
            
            $map = array(
                array( new HTMLText( 'ID' ), new HTMLText( $entry['news_id'] ) ),
                array( new HTMLText( 'Titel' ), new HTMLInput( 'title', 'text', 80, 120, $entry['news_title'], 'formtext', '' ) ),
                array( new HTMLText( 'Bild' ), new HTMLInput( 'pic', 'file', 80, 120, '', 'formtext', '' ) ),
                array( new HTMLText( 'Text' ), new HTMLTemplate( 'editor.html', array( "{CONTENT}" => ""), 'formtext', '' ) ),
                array( new HTMLText( '' ), $control )
            );
            
            $table = new HTMLTable( $map, 'newslist' );
            
            $form = new HTMLForm( '?', 'post', true, 'newform' );
            $form->setSubmitHandler( "return submitForm();" );
            
            $form->addElement( new HTMLHidden( 'action', 'create' ) );
            $form->addElement( new HTMLHidden( 'content', '', '', 'content' ) );
            
            $form->addElement( new HTMLHidden( 'MAX_FILE_SIZE', $_CFG['MAX_FILE_SIZE'] ) );
            $form->addElement( $table );
            
            $this->addElement( $form );              
        }        
    };

    class NewsFormUpdate extends HTMLDiv
    {
        function NewsFormUpdate( $entry )
        {
            global $_CFG;
            
            parent::HTMLElement( 'newsform', '', NULL );
            
            $backbutton = new HTMLButton( 'button', false, 'Zurck', 'formtext', '' );
            $backbutton->setClickHandler( 'document.location = "?action=admin"' );
            
            $control = new HTMLSpan;
            $control->addElement( $backbutton );
            $control->addElement( new HTMLButton( 'submit', true, 'Speichern', 'formtext', '' ) );
            
            $map = array(
                array( new HTMLText( 'ID' ), new HTMLText( $entry['news_id'] ) ),
                array( new HTMLText( 'Datum' ), new HTMLInput( 'date', 'text', 10, 10, $entry['news_date'], 'formtext', '' ) ),
                array( new HTMLText( 'Titel' ), new HTMLInput( 'title', 'text', 80, 120, $entry['news_title'], 'formtext', '' ) ),
                array( new HTMLText( 'Bild' ), new HTMLInput( 'pic', 'file', 80, 120, '', 'formtext', '' ) ),
                array( new HTMLText( 'aktuelles Bild' ), new HTMLImage( 'pic/'.$entry['news_pic'], 64, 64, 0 ) ),
                array( new HTMLText( 'Text' ), new HTMLTemplate( 'editor.html', array( "{CONTENT}" => urlencode($entry['news_text'])), 'formtext', '' ) ),
                array( new HTMLText( 'aktiv' ), new HTMLCheckBox( 'flag', "1", $entry['news_flag'] == 1, 'formtext' ) ),
                array( new HTMLText( '' ), $control )
            );
            
            $table = new HTMLTable( $map, 'newslist' );
            
            $form = new HTMLForm( '?', 'post', true, 'newsform' );
            $form->setSubmitHandler( "return submitForm();" );

            $form->addElement( new HTMLHidden( 'action', 'update' ) );
            $form->addElement( new HTMLHidden( 'content', '', '', 'content' ) );
            $form->addElement( new HTMLHidden( 'id', $entry['news_id'] ) );
            $form->addElement( new HTMLHidden( 'MAX_FILE_SIZE', $_CFG['MAX_FILE_SIZE'] ) );
            $form->addElement( $table );
            
            $this->addElement( $form );              
        }
    };
    
    class NewsLogin extends HTMLDiv
    {
        function NewsLogin()
        {
            parent::HTMLElement( 'newsform', '', NULL );
            $map = array(
                array( new HTMLText( 'Passwort' ), new HTMLInput( 'password', 'password', 20, 32, '', 'formtext', '' ) ),
                array( new HTMLText( '' ), new HTMLButton( 'submit', true, 'Anmelden', 'formtext', '' ) )
            );
            $table = new HTMLTable( $map, 'newslist' );
            $form = new HTMLForm( '?', 'post', true, 'newsform' );
            $form->addElement( new HTMLHidden( 'action', 'login' ) );
            $form->addElement( $table );
            
            $this->addElement( $form );              
        }       
    }

?>