<?
class Params
{
    function getParam( $key, $default )
    {
        if( isset( $_GET[$key] ) && ($_GET[$key] != "") )
            return trim( $_GET[$key] );
        if( isset( $_POST[$key] ) && ($_POST[$key] != "") )
            return trim( $_POST[$key] );
        if( isset( $_COOKIE[$key] ) && ($_COOKIE[$key] != "") )
            return trim( $_COOKIE[$key] );
        return $default;
    }
    
    function clearParam( $key )
    {
        unset( $_GET[$key], $_POST[$key] );
    }
};

class Session
{
    function __construct( Params $param )
    {
        if( $param->GetParam( 'action', '' ) === 'logout' )
        {
            $this->logout();
            return;
        }
        
        session_start();
    }

    function logout()
    {
        global $_CFG;
    
        session_start();
        $_SESSION = array();

        session_destroy();

        header( "location: ".$_CFG['AFTER_LOGOUT_URL'] );
    }
    
    function __destruct()
    {
    }

    function setCookie( $key, $value, $time = 2592000 )
    {
        setCookie( $key, $value, time() + $time );
    }
    
    function getCookie( $key, $default )
    {
        if( isset( $_COOKIE[$key] ) && $_COOKIE[$key] != "" )
            return $_COOKIE[$key];
        else
            return $default;
    }
};

class System
{
    function getLanguage()
    {
        $lang = Params::getParam( "lang", "--" );
        if( $lang == "--" )
            $lang = Session::getCookie( "lang", "--" );
        if( $lang == "--" && isset( $_SERVER['HTTP_ACCEPT_LANGUAGE'] ) )
            $lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
        if( $lang != "de" )            
            $lang = "en";
        System::setLanguage( $lang );
        return $lang;
    }
    
    function setLanguage( $lang )
    {    
        Session::setCookie( "lang", $lang, 365 * 24 * 60 * 60 );
    }  
    
};


?>